mail.sh: include copy/rename detection warnings
[girocco/readme.git] / shlib.sh
blob16d15a6e43637884f6fc4d44662bbfc9de0305ef
1 #!/bin/sh
3 # This is generic shell library for all the scripts used by Girocco;
4 # most importantly, it introduces all the $cfg_* shell variables.
6 # hash patterns
7 hexdig='[0-9a-f]'
8 octet="$hexdig$hexdig"
9 octet4="$octet$octet$octet$octet"
10 octet19="$octet4$octet4$octet4$octet4$octet$octet$octet"
11 octet20="$octet4$octet4$octet4$octet4$octet4"
12 # tab (single \t between single quotes)
13 tab=' '
15 # set a sane umask that never excludes any user or group permissions
16 umask $(printf '0%03o' $(( $(umask) & ~0770 )) )
18 vcmp() {
19 # Compare $1 to $2 each of which must match \d+(\.\d+)*
20 # An empty string ('') for $1 or $2 is treated like 0
21 # Outputs:
22 # -1 if $1 < $2
23 # 0 if $1 = $2
24 # 1 if $1 > $2
25 # Note that `vcmp 1.8 1.8.0.0.0.0` correctly outputs 0.
26 while
27 _a="${1%%.*}"
28 _b="${2%%.*}"
29 [ -n "$_a" ] || [ -n "$_b" ]
31 if [ "${_a:-0}" -lt "${_b:-0}" ]; then
32 echo -1
33 return
34 elif [ "${_a:-0}" -gt "${_b:-0}" ]; then
35 echo 1
36 return
38 _a2="${1#$_a}"
39 _b2="${2#$_b}"
40 set -- "${_a2#.}" "${_b2#.}"
41 done
42 echo 0
45 unset orig_path
46 get_girocco_config_pm_var_list() (
47 # Export all the variables from Girocco::Config to suitable var= lines
48 # prefixing them with 'cfg_'. E.g. $cfg_admin is admin's mail address now
49 # and also setting a 'defined_cfg_' prefix to 1 if they are not undef.
50 __girocco_conf="$GIROCCO_CONF"
51 [ -n "$__girocco_conf" ] || __girocco_conf="Girocco::Config"
52 [ -z "$basedir" ] || __girocco_extrainc="-I$basedir"
53 [ -z "$orig_path" ] || { PATH="$orig_path" && export PATH; }
54 perl -I@basedir@ $__girocco_extrainc -M$__girocco_conf -le \
55 'foreach (sort {uc($a) cmp uc($b)} keys %Girocco::Config::) {
56 my $val = ${$Girocco::Config::{$_}}; defined($val) or $val="";
57 $val =~ s/([\\"\$\`])/\\$1/gos;
58 $val =~ s/(?:\r\n|\r|\n)$//os;
59 print "cfg_$_=\"$val\"";
60 print "defined_cfg_$_=",
61 (defined(${$Girocco::Config::{$_}})?"1":"");
65 # Returns full command path for "$1" if it's a valid command otherwise returns "$1"
66 _fcp() {
67 if _fp="$(command -v "$1" 2>/dev/null)"; then
68 printf '%s\n' "$_fp"
69 else
70 printf '%s\n' "$1"
74 get_girocco_config_var_list() (
75 # Same as get_girocco_config_pm_var_list except that
76 # the following variables (all starting with var_) are added:
77 # var_group cfg_owning_group if defined otherwise `id -gn`
78 # var_git_ver The version number part from `git version`
79 # var_git_exec_path The result of $cfg_git_bin --exec-dir
80 # var_sh_bin Full path to the posix sh interpreter to use
81 # var_perl_bin Full path to the perl interpreter to use
82 # var_gzip_bin Full path to the gzip executable to use
83 # var_nc_openbsd_bin Full path to the netcat (nc) with -U support
84 # var_have_git_171 Set to 1 if git version >= 1.7.1 otherwise ''
85 # var_have_git_172 Set to 1 if git version >= 1.7.2 otherwise ''
86 # var_have_git_173 Set to 1 if git version >= 1.7.3 otherwise ''
87 # var_have_git_1710 Set to 1 if git version >= 1.7.10 otherwise ''
88 # var_have_git_185 Set to 1 if git version >= 1.8.5 otherwise ''
89 # var_have_git_210 Set to 1 if git version >= 2.1.0 otherwise ''
90 # var_have_git_235 Set to 1 if git version >= 2.3.5 otherwise ''
91 # var_have_git_260 Set to 1 if git version >= 2.6.0 otherwise ''
92 # var_have_git_2101 Set to 1 if git version >= 2.10.1 otherwise ''
93 # var_window_memory Value to use for repack --window-memory=
94 # var_big_file_threshold Value to use for core.bigFileThreshold
95 # var_redelta_threshold Recompute deltas if no more than this many objs
96 # var_upload_window If not "", pack.window to use for upload-pack
97 # var_log_window_size Value to use for git-svn --log-window-size=
98 # var_utf8_locale Value to use for a UTF-8 locale if available
99 # var_xargs_r A "-r" if xargs needs it to behave correctly
100 # var_du_exclude Option to exclude PATTERN from du if available
101 # var_du_follow Option to follow command line sym links if available
102 _cfg_vars="$(get_girocco_config_pm_var_list)"
103 eval "$_cfg_vars"
104 printf '%s\n' "$_cfg_vars"
105 printf 'var_group=%s\n' "${cfg_owning_group:-$(id -gn)}"
106 _gver="$("$cfg_git_bin" version 2>/dev/null |
107 LC_ALL=C sed -ne 's/^[^0-9]*\([0-9][0-9]*\(\.[0-9][0-9]*\)*\).*$/\1/p')"
108 printf 'var_git_ver=%s\n' "$_gver"
109 printf 'var_git_exec_path="%s"\n' "$("$cfg_git_bin" --exec-path 2>/dev/null)"
110 printf 'var_sh_bin="%s"\n' "$(_fcp "${cfg_posix_sh_bin:-/bin/sh}")"
111 printf 'var_perl_bin="%s"\n' "$(_fcp "${cfg_perl_bin:-$(unset -f perl; command -v perl)}")"
112 printf 'var_gzip_bin="%s"\n' "$(_fcp "${cfg_gzip_bin:-$(unset -f gzip; command -v gzip)}")"
113 printf 'var_nc_openbsd_bin="%s"\n' "$(_fcp "${cfg_nc_openbsd_bin:-$(unset -f nc; command -v nc)}")"
114 printf 'var_have_git_171=%s\n' "$([ $(vcmp "$_gver" 1.7.1) -ge 0 ] && echo 1)"
115 printf 'var_have_git_172=%s\n' "$([ $(vcmp "$_gver" 1.7.2) -ge 0 ] && echo 1)"
116 printf 'var_have_git_173=%s\n' "$([ $(vcmp "$_gver" 1.7.3) -ge 0 ] && echo 1)"
117 printf 'var_have_git_1710=%s\n' "$([ $(vcmp "$_gver" 1.7.10) -ge 0 ] && echo 1)"
118 printf 'var_have_git_185=%s\n' "$([ $(vcmp "$_gver" 1.8.5) -ge 0 ] && echo 1)"
119 printf 'var_have_git_210=%s\n' "$([ $(vcmp "$_gver" 2.1.0) -ge 0 ] && echo 1)"
120 printf 'var_have_git_235=%s\n' "$([ $(vcmp "$_gver" 2.3.5) -ge 0 ] && echo 1)"
121 printf 'var_have_git_260=%s\n' "$([ $(vcmp "$_gver" 2.6.0) -ge 0 ] && echo 1)"
122 printf 'var_have_git_2101=%s\n' "$([ $(vcmp "$_gver" 2.10.1) -ge 0 ] && echo 1)"
123 __girocco_conf="$GIROCCO_CONF"
124 [ -n "$__girocco_conf" ] || __girocco_conf="Girocco::Config"
125 [ -z "$basedir" ] || __girocco_extrainc="-I$basedir"
126 printf "var_window_memory=%s\n" \
127 "$(perl -I@basedir@ $__girocco_extrainc -M$__girocco_conf \
128 -MGirocco::Util -e 'print calc_windowmemory')"
129 printf "var_big_file_threshold=%s\n" \
130 "$(perl -I@basedir@ $__girocco_extrainc -M$__girocco_conf \
131 -MGirocco::Util -e 'print calc_bigfilethreshold')"
132 printf "var_redelta_threshold=%s\n" \
133 "$(perl -I@basedir@ $__girocco_extrainc -M$__girocco_conf \
134 -MGirocco::Util -e 'print calc_redeltathreshold')"
135 if [ -n "$cfg_upload_pack_window" ] && [ "$cfg_upload_pack_window" -ge 2 ] &&
136 [ "$cfg_upload_pack_window" -le 50 ]; then
137 printf "var_upload_window=%s\n" "$cfg_upload_pack_window"
138 else
139 printf "var_upload_window=%s\n" ""
141 printf 'var_log_window_size=%s\n' "${cfg_svn_log_window_size:-250}"
142 # We parse the output of `locale -a` and select a suitable UTF-8 locale.
143 _guess_locale="$(locale -a | LC_ALL=C grep -viE '^(posix|c)(\..*)?$' |
144 LC_ALL=C grep -iE '\.utf-?8$' | LC_ALL=C sed -e 's/\.[Uu][Tt][Ff]-*8$//' |
145 LC_ALL=C sed -e '/en_US/ s/^/0 /; /en_US/ !s/^/1 /' | LC_ALL=C sort |
146 head -n 1 | LC_ALL=C cut -d ' ' -f 2)"
147 [ -z "$_guess_locale" ] || printf 'var_utf8_locale=%s.UTF-8\n' "$_guess_locale"
148 # On some broken platforms running xargs without -r and empty input runs the command
149 printf 'var_xargs_r=%s\n' "$(</dev/null command xargs printf %s -r)"
150 # The disk usage report produces better numbers if du has an exclude option
151 _x0="$(basename "$0")"
152 _x0="${_x0%?}?*"
153 for _duopt in --exclude -I; do
154 if _test="$(du $_duopt 's?lib.s*' $_duopt "$_x0" "$0" 2>/dev/null)" && [ -z "$_test" ]; then
155 printf 'var_du_exclude=%s\n' "$_duopt"
156 break
158 done
159 if _test="$(du -H "$0" 2>/dev/null)" && [ -n "$_test" ]; then
160 printf 'var_du_follow=%s\n' "-H"
161 break
165 # If basedir has been replaced, and shlib_vars.sh exists, get the config
166 # definitions from it rather than running Perl.
167 if [ "@basedir@" = '@'basedir'@' ] || ! [ -r "@basedir@/shlib_vars.sh" ]; then
168 # Import all the variables from Girocco::Config to the local environment,
169 eval "$(get_girocco_config_var_list)"
170 else
171 # Import the variables from shlib_vars.sh which avoids needlessly
172 # running another copy of Perl
173 . "@basedir@/shlib_vars.sh"
176 # git_add_config "some.var=value"
177 # every ' in value must be replaced with the 4-character sequence '\'' before
178 # calling this function or Git will barf. Will not be effective unless running
179 # Git version 1.7.3 or later.
180 git_add_config() {
181 GIT_CONFIG_PARAMETERS="${GIT_CONFIG_PARAMETERS:+$GIT_CONFIG_PARAMETERS }'$1'"
182 export GIT_CONFIG_PARAMETERS
185 # Make sure we have a reproducible environment by using a controlled HOME dir
186 XDG_CONFIG_HOME="$cfg_chroot/var/empty"
187 HOME="$cfg_chroot/etc/girocco"
188 TMPDIR="/tmp"
189 GIT_CONFIG_NOSYSTEM=1
190 GIT_ATTR_NOSYSTEM=1
191 GIT_NO_REPLACE_OBJECTS=1
192 GIT_TERMINAL_PROMPT=0
193 GIT_PAGER="cat"
194 PAGER="cat"
195 GIT_ASKPASS="$cfg_basedir/bin/git-askpass-password"
196 GIT_SVN_NOTTY=1
197 GIROCCO_SUPPRESS_AUTO_GC_UPDATE=1
198 SVN_SSH="$cfg_basedir/bin/git-svn-ssh"
199 export XDG_CONFIG_HOME
200 export HOME
201 export TMPDIR
202 export GIT_CONFIG_NOSYSTEM
203 export GIT_ATTR_NOSYSTEM
204 export GIT_NO_REPLACE_OBJECTS
205 export GIT_TERMINAL_PROMPT
206 export GIT_PAGER
207 export PAGER
208 export GIT_ASKPASS
209 export GIT_SVN_NOTTY
210 export GIROCCO_SUPPRESS_AUTO_GC_UPDATE
211 export SVN_SSH
212 unset GIT_USER_AGENT
213 unset GIT_HTTP_USER_AGENT
214 if [ -n "$defined_cfg_git_client_ua" ]; then
215 GIT_USER_AGENT="$cfg_git_client_ua"
216 export GIT_USER_AGENT
217 GIT_HTTP_USER_AGENT="$cfg_git_client_ua"
218 export GIT_HTTP_USER_AGENT
220 unset GIT_CONFIG_PARAMETERS
221 git_add_config "core.ignoreCase=false"
222 git_add_config "core.pager=cat"
223 if [ -n "$cfg_git_no_mmap" ]; then
224 # Just like compiling with NO_MMAP
225 git_add_config "core.packedGitWindowSize=1m"
226 else
227 # Always use the 32-bit default (32m) even on 64-bit to avoid memory blowout
228 git_add_config "core.packedGitWindowSize=32m"
230 [ -z "$var_big_file_threshold" ] ||
231 git_add_config "core.bigFileThreshold=$var_big_file_threshold"
232 git_add_config "gc.auto=0"
234 # Make sure any sendmail.pl config is always available
235 unset SENDMAIL_PL_HOST
236 unset SENDMAIL_PL_PORT
237 unset SENDMAIL_PL_NCBIN
238 unset SENDMAIL_PL_NCOPT
239 [ -z "$cfg_sendmail_pl_host" ] || { SENDMAIL_PL_HOST="$cfg_sendmail_pl_host" && export SENDMAIL_PL_HOST; }
240 [ -z "$cfg_sendmail_pl_port" ] || { SENDMAIL_PL_PORT="$cfg_sendmail_pl_port" && export SENDMAIL_PL_PORT; }
241 [ -z "$cfg_sendmail_pl_ncbin" ] || { SENDMAIL_PL_NCBIN="$cfg_sendmail_pl_ncbin" && export SENDMAIL_PL_NCBIN; }
242 [ -z "$cfg_sendmail_pl_ncopt" ] || { SENDMAIL_PL_NCOPT="$cfg_sendmail_pl_ncopt" && export SENDMAIL_PL_NCOPT; }
244 # Set PATH and PYTHON to the values set by Config.pm, if any
245 unset PYTHON
246 [ -z "$cfg_python" ] || { PYTHON="$cfg_python" && export PYTHON; }
247 [ -z "$cfg_path" ] || { orig_path="$PATH" && PATH="$cfg_path" && export PATH; }
249 # Extra GIT variables that generally ought to be cleared, but whose clearing
250 # could potentially interfere with the correct operation of hook scripts so
251 # they are segregated into a separate function for use as appropriate
252 clean_git_env() {
253 unset GIT_ALTERNATE_OBJECT_DIRECTORIES
254 unset GIT_CONFIG
255 unset GIT_DIR
256 unset GIT_GRAFT_FILE
257 unset GIT_INDEX_FILE
258 unset GIT_OBJECT_DIRECTORY
259 unset GIT_NAMESPACE
262 # We cannot use a git() {} or nc_openbsd() {} function to redirect git
263 # and nc_openbsd to the desired executables because when using
264 # "ENV_VAR=xxx func" the various /bin/sh implementations behave in various
265 # different and unexpected ways:
266 # a) treat "ENV_VAR=xxx" like a separate, preceding "export ENV_VAR=xxx"
267 # b) treat "ENV_VAR=xxx" like a separate, prededing "ENV_VAR=xxx"
268 # c) treat "ENV_VAR=xxx" like a temporary setting only while running func
269 # None of these are good. We want a temporary "export ENV_VAR=xxx"
270 # setting only while running func which none of the /bin/sh's do.
272 # Instead we'd like to use an alias that provides the desired behavior without
273 # any of the bad (a), (b) or (c) effects.
275 # However, unfortunately, some of the crazy /bin/sh implementations do not
276 # recognize alias expansions when preceded by variable assignments!
278 # So we are left with git() {} and nc_openbsd() {} functions and in the
279 # case of git() {} we can compensate for (b) and (c) failing to export
280 # but not (a) and (b) persisting the values so the caller will simply
281 # have to beware and explicitly unset any variables that should not persist
282 # beyond the function call itself.
284 git() (
285 [ z"${GIT_DIR+set}" != z"set" ] || export GIT_DIR
286 [ z"${GIT_SSL_NO_VERIFY+set}" != z"set" ] || export GIT_SSL_NO_VERIFY
287 [ z"${GIT_TRACE_PACKET+set}" != z"set" ] || export GIT_TRACE_PACKET
288 [ z"${GIT_USER_AGENT+set}" != z"set" ] || export GIT_USER_AGENT
289 [ z"${GIT_HTTP_USER_AGENT+set}" != z"set" ] || export GIT_HTTP_USER_AGENT
290 exec "$cfg_git_bin" "$@"
293 # Since we do not yet require at least Git 1.8.5 this is a compatibility function
294 # that allows us to use git update-ref --stdin where supported and the slow shell
295 # script where not, but only the "delete" operation is currently supported.
296 git_updateref_stdin() {
297 if [ -n "$var_have_git_185" ]; then
298 git update-ref --stdin
299 else
300 while read -r _op _ref; do
301 case "$_op" in
302 delete)
303 git update-ref -d "$_ref"
306 echo "bad git_updateref_stdin op: $_op" >&2
307 exit 1
309 esac
310 done
314 # see comments for git() -- callers must explicitly export all variables
315 # intended for the commands these functions run before calling them
316 perl() { command "${var_perl_bin:-perl}" "$@"; }
317 gzip() { command "${var_gzip_bin:-gzip}" "$@"; }
319 nc_openbsd() { command "$var_nc_openbsd_bin" "$@"; }
321 list_packs() { command "$cfg_basedir/bin/list_packs" "$@"; }
323 readlink() { command "$cfg_basedir/bin/readlink" "$@"; }
325 strftime() { command "$cfg_basedir/bin/strftime" "$@"; }
327 # Some platforms' broken xargs runs the command always at least once even if
328 # there's no input unless given a special option. Automatically supply the
329 # option on those platforms by providing an xargs function.
330 xargs() { command xargs $var_xargs_r "$@"; }
332 _addrlist() {
333 _list=
334 for _addr in "$@"; do
335 [ -z "$_list" ] || _list="$_list, "
336 _list="$_list$_addr"
337 done
338 echo "$_list"
341 _sendmail() {
342 _mailer="${cfg_sendmail_bin:-/usr/sbin/sendmail}"
343 if [ -n "$cfg_sender" ]; then
344 "$_mailer" -i -f "$cfg_sender" "$@"
345 else
346 "$_mailer" -i "$@"
350 # First argument is an id WITHOUT surrounding '<' and '>' to use in a
351 # "References:" header. It may be "" to suppress the "References" header.
352 # Following arguments are just like mail function
353 mailref() {
354 _references=
355 if [ $# -ge 1 ]; then
356 _references="$1"
357 shift
359 _subject=
360 if [ "$1" = "-s" ]; then
361 shift
362 _subject="$1"
363 shift
366 echo "From: \"$cfg_name\" ($cfg_title) <$cfg_admin>"
367 echo "To: $(_addrlist "$@")"
368 [ -z "$_subject" ] || echo "Subject: $_subject"
369 echo "MIME-Version: 1.0"
370 echo "Content-Type: text/plain; charset=UTF-8"
371 echo "Content-Transfer-Encoding: 8bit"
372 [ -z "$_references" ] || echo "References: <$_references>"
373 [ -n "$cfg_suppress_x_girocco" ] || echo "X-Girocco: $cfg_gitweburl"
374 echo "Auto-Submitted: auto-generated"
375 echo ""
377 } | _sendmail "$@"
380 # Usage: mail [-s <subject>] <addr> [<addr>...]
381 mail() {
382 mailref "" "$@"
385 # bang CMD... will execute the command with well-defined failure mode;
386 # set bang_action to string of the failed action ('clone', 'update', ...);
387 # re-define the bang_trap() function to do custom cleanup before bailing out
388 bang() {
389 bang_errcode=
390 bang_catch "$@"
391 [ "${bang_errcode:-0}" = "0" ] || bang_failed
394 bang_catch() {
395 bang_active=1
396 bang_cmd="$*"
397 bang_errcode=0
398 if [ "${show_progress:-0}" != "0" ]; then
399 exec 3>&1
400 read -r bang_errcode <<-EOT || :
402 exec 4>&3 3>&1 1>&4 4>&-
403 { "$@" 3>&- || echo $? >&3; } 2>&1 | tee -i -a "$bang_log"
406 exec 3>&-
407 if [ -z "$bang_errcode" ] || [ "$bang_errcode" = "0" ]; then
408 # All right. Cool.
409 bang_active=
410 bang_cmd=
411 return;
413 else
414 if "$@" >>"$bang_log" 2>&1; then
415 # All right. Cool.
416 bang_active=
417 bang_cmd=
418 return;
419 else
420 bang_errcode="$?"
425 bang_failed() {
426 bang_active=
427 unset GIT_DIR
428 >.banged
429 cat "$bang_log" >.banglog
430 echo "" >>.banglog
431 echo "$bang_cmd failed with error code $bang_errcode" >>.banglog
432 ! [ -d htmlcache ] || { >htmlcache/changed; } 2>/dev/null || :
433 if [ "${show_progress:-0}" != "0" ]; then
434 echo ""
435 echo "$bang_cmd failed with error code $bang_errcode"
437 if [ -e .bangagain ]; then
438 git config --remove-section girocco.bang 2>/dev/null || :
439 rm -f .bangagain
441 bangcount="$(git config --int girocco.bang.count 2>/dev/null)" || :
442 bangcount=$(( ${bangcount:-0} + 1 ))
443 git config --int girocco.bang.count $bangcount
444 if [ $bangcount -eq 1 ]; then
445 git config girocco.bang.firstfail "$(TZ=UTC date "+%Y-%m-%d %T UTC")"
447 if [ $bangcount -ge $cfg_min_mirror_failure_message_count ] &&
448 [ "$(git config --bool girocco.bang.messagesent 2>/dev/null || :)" != "true" ] &&
449 ! check_interval "girocco.bang.firstfail" $cfg_min_mirror_failure_message_interval; then
450 bangmailok="$(git config --bool gitweb.statusupdates 2>/dev/null || echo true)"
451 bangaddrs=
452 [ "$bangmailok" = "false" ] || [ -z "$mail" ] || bangaddrs="$mail"
453 [ -z "$cfg_admincc" ] || [ "$cfg_admincc" = "0" ] || [ -z "$cfg_admin" ] ||
454 if [ -z "$bangaddrs" ]; then bangaddrs="$cfg_admin"; else bangaddrs="$bangaddrs,$cfg_admin"; fi
455 rsubj=
456 [ $bangcount -le 1 ] || rsubj=" repeatedly"
457 [ -z "$bangaddrs" ] ||
459 echo "$bang_cmd failed with error code $bang_errcode"
460 echo ""
461 rsubj=
462 if [ $bangcount -gt 1 ]; then
463 echo "$bangcount consecutive update failures have occurred since $(config_get girocco.bang.firstfail)"
464 echo ""
466 echo "you will not receive any more notifications until recovery"
467 echo "this status message may be disabled on the project admin page"
468 echo ""
469 echo "Log follows:"
470 echo ""
471 cat "$bang_log"
472 } | mailref "update@$cfg_gitweburl/$proj.git" -s "[$cfg_name] $proj $bang_action failed$rsubj" "$bangaddrs"
473 git config --bool girocco.bang.messagesent true
475 bangthrottle=
476 [ $bangcount -lt 15 ] ||
477 check_interval "girocco.bang.firstfail" $(( $cfg_min_mirror_interval * 3 / 2 )) ||
478 bangthrottle=1
479 bang_trap $bangthrottle
480 [ -n "$bang_errcode" ] && [ "$bang_errcode" != "0" ] || bang_errcode=1
481 exit $bang_errcode
484 # bang_eval CMD... will evaluate the command with well-defined failure mode;
485 # Identical to bang CMD... except the command is eval'd instead of executed.
486 bang_eval() {
487 bang eval "$*"
490 # Default bang settings:
491 bang_setup() {
492 bang_active=
493 bang_action="lame_programmer"
494 bang_trap() { :; }
495 bang_tmpdir="${TMPDIR:-/tmp}"
496 bang_tmpdir="${bang_tmpdir%/}"
497 bang_log="$(mktemp "${bang_tmpdir:-/tmp}/repomgr-XXXXXX")"
498 is_git_dir . || {
499 echo "bang_setup called with current directory not a git directory" >&2
500 exit 1
502 trap 'rm -f "$bang_log"' EXIT
503 trap '[ -z "$bang_active" ] || { bang_errcode=130; bang_failed; }; exit 130' INT
504 trap '[ -z "$bang_active" ] || { bang_errcode=143; bang_failed; }; exit 143' TERM
507 # Remove banged status
508 bang_reset() {
509 rm -f .banged .bangagain .banglog
510 git config --remove-section girocco.bang 2>/dev/null || :
513 # Check to see if banged status
514 is_banged() {
515 [ -e .banged ]
518 # Check to see if banged message was sent
519 was_banged_message_sent() {
520 [ "$(git config --bool girocco.bang.messagesent 2>/dev/null || :)" = "true" ]
523 # Progress report - if show_progress is set, shows the given message.
524 progress() {
525 [ "${show_progress:-0}" = "0" ] || echo "$*"
528 # Project config accessors; must be run in project directory
529 config_get() {
530 case "$1" in
531 *.*)
532 git config "$1";;
534 git config "gitweb.$1";;
535 esac
538 config_set() {
539 git config "gitweb.$1" "$2" && chgrp $var_group config && chmod g+w config
542 config_set_raw() {
543 git config "$1" "$2" && chgrp $var_group config && chmod g+w config
546 config_get_date_seconds() {
547 _dt="$(config_get "$1")" || :
548 [ -n "$_dt" ] || return 1
549 _ds="$(perl -I@basedir@ -MGirocco::Util -e "print parse_any_date('$_dt')")"
550 [ -n "$_ds" ] || return 1
551 echo "$_ds"
554 # Tool for checking whether given number of seconds has not passed yet
555 check_interval() {
556 os="$(config_get_date_seconds "$1")" || return 1
557 ns="$(date +%s)"
558 [ $ns -lt $(($os+$2)) ]
561 # Check if we are running with effective root permissions
562 is_root() {
563 [ "$(id -u 2>/dev/null)" = "0" ]
566 # Check to see if the single argument is a Git directory
567 is_git_dir() {
568 # Just like Git's test except we ignore GIT_OBJECT_DIRECTORY
569 # And we are slightly more picky (must be refs/.+ not refs/.*)
570 [ -d "$1/objects" ] && [ -x "$1/objects" ] || return 1
571 [ -d "$1/refs" ] && [ -x "$1/refs" ] || return 1
572 if [ -L "$1/HEAD" ]; then
573 _hr="$(readlink "$1/HEAD")"
574 case "$_hr" in "refs/"?*) :;; *) return 1;; esac
576 [ -f "$1/HEAD" ] && [ -r "$1/HEAD" ] || return 1
577 read -r _hr <"$1/HEAD" || return 1
578 case "$_hr" in
579 $octet20*)
580 [ "${_hr#*[!0-9a-f]}" = "$_hr" ] || return 1
581 return 0;;
582 ref:refs/?*)
583 return 0;;
584 ref:*)
585 _hr="${_hr##ref:*[ $tab]}"
586 case "$_hr" in "refs/"?*) return 0;; esac
587 esac
588 return 1
591 # List all Git repositories, with given prefix if specified, one-per-line
592 # All project names starting with _ are always excluded from the result
593 get_repo_list() {
594 if [ -n "$1" ]; then
595 LC_ALL=C cut -d : -f 1,3 "$cfg_chroot"/etc/group | LC_ALL=C grep "^$1"
596 else
597 LC_ALL=C cut -d : -f 1,3 "$cfg_chroot"/etc/group
598 fi | while IFS=: read name id; do
599 [ $id -lt 65536 ] || case "$name" in _*) :;; ?*) echo "$name"; esac
600 done
603 # set the variable named by the first argument to the project part (i.e. WITH
604 # the trailing ".git" but WITHOUT the leading $cfg_reporoot) of the directory
605 # specified by the second argument.
606 # This function cannot be fooled by symbolic links.
607 # If the second argument is omitted (or empty) use $(pwd -P) instead.
608 # The directory specified by the second argument must exist.
609 v_get_proj_from_dir() {
610 [ -n "$2" ] || set -- "$1" "$(pwd -P)"
611 [ -d "$2" ] || return 1
612 case "$2" in
613 "$cfg_reporoot/"?*)
614 # Simple case that does not need any fancy footwork
615 _projpart="${2#$cfg_reporoot/}"
618 _absrr="$(cd "$cfg_reporoot" && pwd -P)"
619 _abspd="$(cd "$2" && pwd -P)"
620 case "$_abspd" in
621 "$_absrr/"?*)
622 # The normal case
623 _projpart="${_abspd#$_absrr/}"
626 # Must have been reached via a symbolic link, but
627 # we have no way to know the source, so use a
628 # generic "_external" leader combined with just the
629 # trailing directory name
630 _abspd="${_abspd%/}"
631 _abspd="${_abspd%/.git}"
632 _projpart="_external/${_abspd##*/}"
634 esac
635 esac
636 eval "$1="'"$_projpart"'
639 # Return success if the given project name has at least one immediate child fork
640 # that has a non-zero length alternates file
641 has_forks_with_alternates() {
642 _prj="${1%.git}"
643 [ -n "$_prj" ] || return 1
644 [ -d "$cfg_reporoot/$_prj" ] || return 1
645 is_git_dir "$cfg_reporoot/$_prj.git" || return 1
647 get_repo_list "$_prj/[^/:][^/:]*:" |
648 while read -r _prjname && [ -n "$_prjname" ]; do
649 ! [ -s "$cfg_reporoot/$_prjname.git/objects/info/alternates" ] ||
650 exit 1 # will only exit implicit subshell created by '|'
651 done
652 then
653 return 1
655 return 0
658 # returns empty string and error for empty string otherwise one of
659 # m => normal Git mirror
660 # s => mirror from svn source
661 # d => mirror from darcs source
662 # b => mirror from bzr source
663 # h => mirror from hg source
664 # w => mirror from mediawiki source
665 # f => mirror from other fast-import source
666 # note that if the string is non-empty and none of s, d, b or h match the
667 # return will always be type m regardless of whether it's a valid Git URL
668 get_url_mirror_type() {
669 case "$1" in
671 return 1
673 svn://* | svn+http://* | svn+https://* | svn+file://* | svn+ssh://*)
674 echo 's'
676 darcs://*)
677 echo 'd'
679 bzr://*)
680 echo 'b'
682 hg+http://* | hg+https://* | hg+file://* | hg+ssh://* | hg::*)
683 echo 'h'
685 mediawiki::*)
686 echo 'w'
689 echo 'm'
691 esac
692 return 0
695 # returns false for empty string
696 # returns true if the passed in url is a mirror using git fast-import
697 is_gfi_mirror_url() {
698 [ -n "$1" ] || return 1
699 case "$(get_url_mirror_type "$1" 2>/dev/null || :)" in
700 d|b|h|w|f)
701 # darcs, bzr, hg and mediawiki mirrors use git fast-import
702 # and so do generic "f" fast-import mirrors
703 return 0
706 # Don't think git-svn currently uses git fast-import
707 # And Git mirrors certainly do not
708 return 1
710 esac
711 # assume it does not use git fast-import
712 return 1
715 # returns false for empty string
716 # returns true if the passed in url is a mirror using git-svn
717 is_svn_mirror_url() {
718 [ -n "$1" ] || return 1
719 [ "$(get_url_mirror_type "$1" 2>/dev/null || :)" = "s" ]
722 # returns mirror url for gitweb.baseurl of git directory
723 # (GIT_DIR) passed in as the argument (which defaults to "." if omitted)
724 # will fail if the directory does not have .nofetch and gitweb.baseurl
725 # comes back empty -- otherwise .nofetch directories succeed with a "" return
726 # automatically strips any leading "disabled " prefix before returning result
727 get_mirror_url() {
728 _gitdir="${1:-.}"
729 # always return empty for non-mirrors
730 ! [ -e "$_gitdir/.nofetch" ] || return 0
731 _url="$(GIT_DIR="$_gitdir" config_get baseurl 2>/dev/null)" || :
732 _url="${_url##* }"
733 [ -n "$_url" ] || return 1
734 printf '%s\n' "$_url"
735 return 0
738 # returns get_url_mirror_type for gitweb.baseurl of git directory
739 # (GIT_DIR) passed in as the argument (which defaults to "." if omitted)
740 # will fail if the directory does not have .nofetch and gitweb.baseurl
741 # comes back empty -- otherwise .nofetch directories succeed with a "" return
742 # automatically strips any leading "disabled " prefix before testing
743 get_mirror_type() {
744 _url="$(get_mirror_url "$@")" || return 1
745 [ -n "$_url" ] || return 0
746 get_url_mirror_type "$_url"
749 # returns true if the passed in git dir (defaults to ".") is a mirror using git fast-import
750 is_gfi_mirror() {
751 _url="$(get_mirror_url "$@")" || return 1
752 is_gfi_mirror_url "$_url"
755 # returns true if the passed in git dir (defaults to ".") is a mirror using git-svn
756 is_svn_mirror() {
757 _url="$(get_mirror_url "$@")" || return 1
758 is_svn_mirror_url "$_url"
761 # current directory must already be set to Git repository
762 # if girocco.headok is already true succeeds without doing anything
763 # if rev-parse --verify HEAD succeeds sets headok=true and succeeds
764 # otherwise tries to set HEAD to a symbolic ref to refs/heads/master
765 # then refs/heads/trunk and finally the first top-level head from
766 # refs/heads/* (i.e. only two slashes in the name) and finally any
767 # existing refs/heads. The first one to succeed wins and sets headok=true
768 # and then a successful exit. Otherwise headok is left unset with a failure exit
769 # We use the girocco.headok flag to make sure we only force a valid HEAD symref
770 # when the repository is being set up -- if the HEAD is later deleted (through
771 # a push or fetch --prune) that's no longer our responsibility to fix
772 check_and_set_head() {
773 [ "$(git config --bool girocco.headok 2>/dev/null || :)" != "true" ] || return 0
774 if git rev-parse --verify --quiet HEAD >/dev/null; then
775 git config --bool girocco.headok true
776 return 0
778 for _hr in refs/heads/master refs/heads/trunk; do
779 if git rev-parse --verify --quiet "$_hr" >/dev/null; then
780 _update_head_symref "$_hr"
781 return 0
783 done
784 git for-each-ref --format="%(refname)" refs/heads 2>/dev/null |
785 while read -r _hr; do
786 case "${_hr#refs/heads/}" in */*) :;; *)
787 _update_head_symref "$_hr"
788 exit 1 # exit subshell created by "|"
789 esac
790 done || return 0
791 _hr="$(git for-each-ref --format="%(refname)" refs/heads 2>/dev/null | head -n 1)" || :
792 if [ -n "$_hr" ]; then
793 _update_head_symref "$_hr"
794 return 0
796 return 1
798 _update_head_symref() {
799 git symbolic-ref HEAD "$1"
800 git config --bool girocco.headok true
801 ! [ -d htmlcache ] || { >htmlcache/changed; } 2>/dev/null || :
804 # current directory must already be set to Git repository
805 # if the directory needs to have gc run and .needsgc is not already set
806 # then .needsgc will be set triggering a "mini" gc at the next opportunity
807 # Girocco shouldn't generate any loose objects but we check for that anyway
808 check_and_set_needsgc() {
809 ! [ -e .needsgc ] || return 0
810 _packs=
811 { _packs="$(list_packs --quiet --count --exclude-no-idx --exclude-keep objects/pack || :)" || :; } 2>/dev/null
812 if [ "${_packs:-0}" -ge 20 ]; then
813 >.needsgc
814 return 0
816 _logfiles=
817 { _logfiles="$(($(find -L reflogs -maxdepth 1 -type f -print | wc -l || :)+0))" || :; } 2>/dev/null
818 if [ "${_logfiles:-0}" -ge 50 ]; then
819 >.needsgc
820 return 0
822 # Truly git gc only checks the number of objects in the objects/17 directory
823 # We check for -ge 10 which should make the probability of having more than
824 # 5120 (20*256) loose objects present when there are less than 10 in
825 # objects/17 vanishingly small (20 is the threshold we use for pack files)
826 _objfiles=
827 ! [ -d objects/17 ] ||
828 { _objfiles="$(($(find -L objects/17 -type f -name "$octet19*" -print | wc -l || :)+0))" || :; } 2>/dev/null
829 if [ "${_objfiles:-0}" -ge 10 ]; then
830 >.needsgc
831 return 0
835 # A well-known UTF-8 locale is required for some of the fast-import providers
836 # in order to avoid mangling characters. Ideally we could use "POSIX.UTF-8"
837 # but that is not reliably UTF-8 but rather usually US-ASCII.
838 # We parse the output of `locale -a` and select a suitable UTF-8 locale at
839 # install time and store that in $var_utf8_locale if one is found.
840 # If we cannot find one in the `locale -a` output then we just use a well-known
841 # UTF-8 locale and hope for the best. We set LC_ALL to our choice and export
842 # it. We only set this temporarily when running the fast-import providers.
843 set_utf8_locale() {
844 LC_ALL="${var_utf8_locale:-en_US.UTF-8}"
845 export LC_ALL
848 # hg-fast-export | git fast-import with error handling in current directory GIT_DIR
849 git_hg_fetch() (
850 set_utf8_locale
851 _python="${PYTHON:-python}"
852 rm -f hg2git-marks.old hg2git-marks.new
853 if [ -f hg2git-marks ] && [ -s hg2git-marks ]; then
854 LC_ALL=C sed 's/^:\([^ ][^ ]*\) \([^ ][^ ]*\)$/\2 \1/' <hg2git-marks | {
855 if [ -n "$var_have_git_185" ]; then
856 git cat-file --batch-check=':%(rest) %(objectname)'
857 else
858 LC_ALL=C sed 's/^\([^ ][^ ]*\) \([^ ][^ ]*\)$/:\2 \1/'
860 } | LC_ALL=C sed '/ missing$/d' >hg2git-marks.old
861 if [ -n "$var_have_git_171" ] &&
862 git rev-parse --quiet --verify refs/notes/hg >/dev/null; then
863 if [ -z "$var_have_git_185" ] ||
864 ! LC_ALL=C cmp -s hg2git-marks hg2git-marks.old; then
865 _nm='hg-fast-export'
866 GIT_AUTHOR_NAME="$_nm"
867 GIT_COMMITTER_NAME="$_nm"
868 GIT_AUTHOR_EMAIL="$_nm"
869 GIT_COMMITTER_EMAIL="$_nm"
870 export GIT_AUTHOR_NAME
871 export GIT_COMMITTER_NAME
872 export GIT_AUTHOR_EMAIL
873 export GIT_COMMITTER_EMAIL
874 git notes --ref=refs/notes/hg prune
875 unset GIT_AUTHOR_NAME
876 unset GIT_COMMITTER_NAME
877 unset GIT_AUTHOR_EMAIL
878 unset GIT_COMMITTER_EMAIL
881 else
882 >hg2git-marks.old
884 _err1=
885 _err2=
886 exec 3>&1
887 { read -r _err1 || :; read -r _err2 || :; } <<-EOT
889 exec 4>&3 3>&1 1>&4 4>&-
891 _e1=0
892 _af="$(git config hg.authorsfile)" || :
893 _cmd='GIT_DIR="$(pwd)" "$_python" "$cfg_basedir/bin/hg-fast-export.py" \
894 --repo "$(pwd)/repo.hg" \
895 --marks "$(pwd)/hg2git-marks.old" \
896 --mapping "$(pwd)/hg2git-mapping" \
897 --heads "$(pwd)/hg2git-heads" \
898 --status "$(pwd)/hg2git-state" \
899 -U unknown --force --flatten --hg-hash'
900 [ -z "$_af" ] || _cmd="$_cmd"' --authors "$_af"'
901 eval "$_cmd" 3>&- || _e1=$?
902 echo $_e1 >&3
905 _e2=0
906 git fast-import \
907 --import-marks="$(pwd)/hg2git-marks.old" \
908 --export-marks="$(pwd)/hg2git-marks.new" \
909 --export-pack-edges="$(pwd)/gfi-packs" \
910 --force 3>&- || _e2=$?
911 echo $_e2 >&3
915 exec 3>&-
916 [ "$_err1" = 0 ] && [ "$_err2" = 0 ] || return 1
917 mv -f hg2git-marks.new hg2git-marks
918 rm -f hg2git-marks.old
919 git for-each-ref --format='%(refname) %(objectname)' refs/heads |
920 LC_ALL=C sed -e 's,^refs/heads/,:,' >hg2git-heads